/* genclass.rexx
# usage: genclass [-2] type1 {ref, val} [type2 {ref, val}] proto [out-prefix]


# search in standard g++ prototype directory
  ported to arexx by Al Villarica
*/

/* PROTODIR='local:g++-include/gen' */
PROTODIR='gcc20:lib/g++-include/gen'

T2=""
T2ACC=""
t2name = ""
t2sedname = ""

parse arg twoargs .

if twoargs = "-2" then
  do
	parse arg twoargs t1 isref1 t2 isref2 class newprefix .
	parse arg twoargs args
  end
else
  do
	parse arg t1 isref1 class newprefix .
	parse arg args
  end

t1name = t1'.'
t1sedname = t1

if isref1 = "ref" then t1acc='\&'
else if isref1 = "val" then t1acc=' '
else do
  say "Must specify type1 access: ref or val"
  exit 1
end

if twoargs = "-2" then
  do
	t2name = t2'.'
	t2sedname = t2
	if isref2 = "ref" then t2acc='\&'
	else if isref2 = "val" then t2acc=' '
	else do
		say "Must specify type2 access: ref or val"
		exit 1
	end
  end

DFLTPREFIX=T1NAME || T2NAME

select
	when words(args) = 3 then prefix = dfltprefix
	when words(args) = 5 then prefix = dfltprefix
	when words(args) = 4 then prefix = newprefix
	when words(args) = 6 then prefix = newprefix
	otherwise do
		say "bad arguments"
		exit 1
	end
end

HSRC=CLASS || '.hP'
CCSRC=CLASS || '.ccP'
HOUT=PREFIX || CLASS || '.h'
CCOUT=PREFIX || CLASS || '.cc'

hsrcfilename = protodir || '/' || hsrc

if open('test', hsrcfilename) then
	HSRC= hsrcfilename
else
	do	
		say "genclass: " || HSRC || ": no such file"
		exit 1
	end


/*
say 'hsrc' hsrc
say 'hout' hout
say 't1' t1
say 't1acc' t1acc
say 't1sedname' t1sedname
say 't2' t2
say 't2acc' t2acc
say 't2sedname' t2sedname
say 'prefix' prefix
*/

if twoargs = "-2" then
	if prefix = newprefix then
	    push 'sed < 'HSRC' > 'HOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g" -e "s/<C>/'T2'/g" -e "s/<C&>/'T2 || T2ACC'/g" -e "s/'T1SEDNAME'\.'T2SEDNAME'\./'PREFIX'/g" -e "s/'T1SEDNAME'\./'PREFIX'/g" -e "s/'T2SEDNAME'\./'PREFIX'/g"'
	else
	    push 'sed < 'HSRC' > 'HOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g" -e "s/<C>/'T2'/g" -e "s/<C&>/'T2 || T2ACC'/g"'
else
	if prefix = newprefix then
	    push 'sed < 'HSRC' > 'HOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g" -e "s/'T1SEDNAME'\./'PREFIX'/g"'
	else
	    push 'sed < 'HSRC' > 'HOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g"'

ccsrcfilename = protodir || '/' || ccsrc

if open('test2', ccsrcfilename) then
	ccsrc = ccsrcfilename
else
	do
		say "genclass warning: class has a .h but no .cc file"
		exit 0
	end

if twoargs = "-2" then
	if prefix = newprefix then
	    push 'sed < 'CCSRC' > 'CCOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g" -e "s/<C>/'T2'/g" -e "s/<C&>/'T2 || T2ACC'/g" -e "s/'T1SEDNAME'\.'T2SEDNAME'\./'PREFIX'/g" -e "s/'T1SEDNAME'\./'PREFIX'/g" -e "s/'T2SEDNAME'\./'PREFIX'/g"'
	else
	    push 'sed < 'CCSRC' > 'CCOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g" -e "s/<C>/'T2'/g" -e "s/<C&>/'T2 || T2ACC'/g"'
else
    if prefix = newprefix then
		push 'sed < 'CCSRC' > 'CCOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g" -e "s/'T1SEDNAME'\./'PREFIX'/g"'
	else
	    push 'sed < 'CCSRC' > 'CCOUT' -e "s/<T>/'T1'/g" -e "s/<T&>/'T1 || T1ACC'/g"'

